#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_fish_scheme.h"
std::auto_ptr<M_fish_scheme> M_fish_scheme::msSingleton(nullptr);

int M_fish_scheme::GetCount()
{
	return (int)mMapData.size();
}

const M_fish_schemeData* M_fish_scheme::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_fish_schemeData>& M_fish_scheme::GetMapData()
{
	return mMapData;
}

void M_fish_scheme::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_fish_scheme.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_fish_schemeData data;
		data.mID = element->IntAttribute("ID");
		data.mmonster_id = element->IntAttribute("monster_id");
		data.mfish_group = element->IntAttribute("fish_group");
		data.mnum = element->IntAttribute("num");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_fish_scheme Loaded. Load Data:%u", mMapData.size());
}

void M_fish_scheme::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_fish_scheme");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_fish_scheme");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_fish_schemeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "monster_id", data.mmonster_id);
		LuaCfgHelper::readInt(L, "fish_group", data.mfish_group);
		LuaCfgHelper::readInt(L, "num", data.mnum);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_fish_scheme Loaded. Load Data:%u", mMapData.size());
}

void M_fish_scheme::Reload()
{
	mMapData.clear();
	Load();
}

M_fish_scheme* M_fish_scheme::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_fish_scheme());
	}
	return msSingleton.get();
}

void M_fish_scheme::Release()
{
	msSingleton.reset(nullptr);
}
